
#include "eyd_uncompressor_rle2.hh"

namespace EydLib {

	BitUncompressorRle2::BitUncompressorRle2(int size) : _wrk_grp(size) {
		_group_size = size;
		_last_count = 0;
		_first_group = true;
		_wrk_pos = 0;
	}

	void BitUncompressorRle2::clear(){
		// we clear everything
		_last_count = 0;
		_uncompressed.clear();
		_first_group = true;
		_wrk_pos = 0;
	}

	void BitUncompressorRle2::appendBit(bool bit){
		_wrk_grp.setBitAt(_wrk_pos, bit);
		printf(" (buf= %s, pos= %d) ",_wrk_grp.toString().c_str(),_wrk_pos);
		_wrk_pos++;
		if (_wrk_pos >= _wrk_grp.size()){
			_uncompressed.push_back(_wrk_grp);
			BitGroup clr(_wrk_grp.size());
			_wrk_grp = clr;
			_wrk_pos = 0;
		}
	}

	void BitUncompressorRle2::append(BitGroup data){
		printf("got %d -> expanding ",data.getValue());
		BitGroup out(1);
		if (_first_group){
			// X zros sans 1 apres 
			for (int i=0; i<data.getValue(); i++){
				this->appendBit(false);
				printf("0");
			}
			_first_group = false;
		} else {
			// 1 suivi de X zeros
			printf("1");
			this->appendBit(true);
			for (int i=0; i<data.getValue(); i++){
				this->appendBit(false);
				printf("0");
			}
		}
		printf("\n");
	}

	std::list<BitGroup> BitUncompressorRle2::flush(){
		// we add the data from _last* to the outlist
		std::list<BitGroup> result;
		result = _uncompressed;
		_uncompressed.clear();
		return result;
	}

	bool BitUncompressorRle2::hasContent(){
		return (!_uncompressed.empty());
	}
}

